# Author: Malcolm Kesson (2007)
set LROOT     PATH_TO_YOUR_LCODE_DIRECTORY
set LSCRIPTS  PATH_TO_YOUR_LSCRIPTS_DIRECTORY

source $LROOT/LScriptReader.tcl
source $LROOT/LGenerator.tcl
source $LROOT/LMan.tcl
  
fconfigure stdout -translation binary
  
while { [gets stdin buffer] != -1 } {
    # The first data item is "pixel coverage"
    # Currently this script ignores its value.
    # set numPixels [lindex $buffer 0]

	# Second data item is the name of a Lscript
	set name [lindex $buffer 1]
	
	#readScript $LSCRIPTS/$name script
	set lines [getScript $LSCRIPTS/$name]

	# Data read from the script file can be overridden 
	# by new values passed to the helper.
	set step 2
	for {set n 2} {$n < [llength $buffer]} {incr n $step} {
		set param  [lindex $buffer $n]
		set value  [lindex $buffer [expr $n + 1]]
		if {$param == "rule" || $param == "statement"} {
			lappend lines [list $param $value [lindex $buffer [expr $n + 2]]]
			#puts "appending rule [list $param $value [lindex $buffer [expr $n + 2]]]"
			set step 3
		} else {
			lappend lines [list $param $value]
			#puts "appending rule [list $param $value]"
			set step 2
			}
		}
	readScript $lines script
	
	# The empty string forces LMan.tcl to use stdout
	# instead of writing a file
    render [generate script] script ""
    
	# Tell the renderer we've finished producing
	# rib statements.
    puts "\377" 
    flush stdout
    }
